import * as METADATA from './constants';

class AppContext {
  private static context: AppContext = null;
  private instanceMap: Map<string, Function>;

  private constructor() {
    this.instanceMap = new Map();
  }

  public put(instance: any, name?: string): void {
    if (typeof name !== 'string') {
      if (instance instanceof Function) {
        name = (<Function>instance).name;
      }
    }
    this.instanceMap.set(name, instance);
  }

  public static getService<T>(clazz: {new(...args: any[]): T}): T {
    let types = Reflect.getMetadata(METADATA.PARAM_TYPES, clazz);

    let i = new clazz();

    return i;
  }

  public static get<T>(): T {


    return null;
  }

  public static put(instance: any, name?: string): void {
    AppContext.getContext().put(instance, name);
  }

  public static getContext(): AppContext {
    if (null === AppContext.context) {
      AppContext.context = new AppContext();
    }
    return AppContext.context;
  }

  public static destroy(): void {
    console.log('AppContext has been destroyed.');
  }

}

export default AppContext;
